<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<!--
IGAC proyecto SNC

@author  		christian.rodriguez
@modified       pedro.garcia  por cambios en el mb debidos a cambios en la bd
@description  	página que permite proyectar una comisión para recoleccion de ofertas inmobiliarias
@cu  			CU-TV-0F-003
@version  		2.0

-->
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="../../../templates/generalCU.xhtml">

    <ui:define name="title">.::Sistema Nacional Catastral::. .::Proyección de ordenes de comisión para ofertas::.</ui:define>
    <ui:define name="content">

        <h:outputScript library="javascript" name="snc_visor_client.js"
                        target="head" />
        <h:outputStylesheet library="css" name="snc_visor_client.css" />

        <p:focus />
        <p:messages id="msgsPOC" showDetail="false" globalOnly="false" />

        <h:form id="proyectarOrdenComisionForm">

            <p:tabView id="proyectarOrdenComisionTV" dynamic="true">

                <p:tab title="Áreas pendientes de comisión" id="areasPendientesId">

                    <legend>
                        <h:outputText styleClass="legendTitle" value="Comisionar áreas" />
                    </legend>

                    <p:spacer height="20" width="0" />

                    <p:dataTable id="regionesPendientesComisionDT"
                                 widgetVar="regionesPendientesComisionWV"
                                 value="#{proyeccionOrdenComisionOfertas.regionesPendientesComision}"
                                 var="regionPendienteComision"
                                 selection="#{proyeccionOrdenComisionOfertas.selectedRegionesPendientesComision}"
                                 rowKey="#{regionPendienteComision.id}" paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                                 {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,50" paginatorPosition="bottom"
                                 emptyMessage="No hay áreas pendientes para comisionar.">

                        <p:ajax event="rowSelect" immediate="true"
                                listener="#{proyeccionOrdenComisionOfertas.agregarManzanaVisorGIS}"
                                update=":proyectarOrdenComisionForm:proyectarOrdenComisionTV:regionesPendientesComisionDT,
                                :proyectarOrdenComisionForm:proyectarOrdenComisionTV:zoomAreaB"
                                onstart="statusDialog2.show();"
                                oncomplete="statusDialog2.hide();" />

                        <p:ajax event="rowUnselect" immediate="true"
                                listener="#{proyeccionOrdenComisionOfertas.eliminarManzanaVisorGIS}"
                                update=":proyectarOrdenComisionForm:proyectarOrdenComisionTV:regionesPendientesComisionDT,
                                :proyectarOrdenComisionForm:proyectarOrdenComisionTV:zoomAreaB"
                                onstart="statusDialog2.show();"
                                oncomplete="statusDialog2.hide();" />

                        <p:column selectionMode="multiple" style="width:18px" />

                        <f:facet name="header">
                            <h:outputText value="Regiones asociadas al áre de recolección" />
                        </f:facet>

                        <p:column headerText="Identificador"
                                  sortBy="#{regionPendienteComision.id}">
                            <h:outputText value="#{regionPendienteComision.id}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Identificador área"
                                  sortBy="#{regionPendienteComision.areaCapturaOferta.id}">
                            <h:outputText
                                value="#{regionPendienteComision.areaCapturaOferta.id}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Departamento"
                                  sortBy="#{regionPendienteComision.areaCapturaOferta.departamento.nombre}">
                            <h:outputText id="departamentoAreaPendiente"
                                          styleClass="outputTextStyle"
                                          value="#{regionPendienteComision.areaCapturaOferta.departamento.nombre}" />
                        </p:column>

                        <p:column headerText="Municipio"
                                  sortBy="#{regionPendienteComision.areaCapturaOferta.municipio.nombre}">
                            <h:outputText id="muinicipioAreaPendiente"
                                          styleClass="outputTextStyle"
                                          value="#{regionPendienteComision.areaCapturaOferta.municipio.nombre}" />
                        </p:column>

                        <p:column headerText="Zona">
                            <h:outputText id="zonaAreaPendiente" styleClass="outputTextStyle"
                                          value="#{regionPendienteComision.areaCapturaOferta.zona.nombre}" />
                        </p:column>

                        <p:column headerText="Recolector"
                                  sortBy="#{regionPendienteComision.asignadoRecolectorNombre}">
                            <h:outputText id="recolectorAreaPendiente"
                                          styleClass="outputTextStyle"
                                          value="#{regionPendienteComision.asignadoRecolectorNombre}" />
                        </p:column>

                        <p:column headerText="Fecha"
                                  sortBy="#{regionPendienteComision.fechaAsignacionRecolector}">
                            <h:outputText id="fechaAreaPendiente"
                                          styleClass="outputTextStyle"
                                          value="#{regionPendienteComision.fechaAsignacionRecolector}" />
                        </p:column>

                        <p:column headerText="Estado"
                                  sortBy="#{regionPendienteComision.estado}">
                            <h:outputText value="#{regionPendienteComision.estado}"
                                          styleClass="outputTextStyle" />
                        </p:column>


                    </p:dataTable>

                    <p:spacer height="10" />

                    <h:panelGrid columns="3" cellspacing="7" id="areasOpcionesPG">
                        <p:commandButton value="Comisionar áreas" icon="ui-icon-script"
                                         action="#{proyeccionOrdenComisionOfertas.validarRegiones}"
                                         onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide();
                                         handleCompleteSIC(xhr, status, args, comisionAreasOfertasDialogWV, true);"
                                         update=":proyectarOrdenComisionForm:proyectarOrdenComisionTV,
                                         :msgsPOC" />
                        <p:commandButton value="Visualizar en visor GIS" id="zoomAreaB"
                                         icon="ui-icon-zoomin" ajax="true"
                                         update=":proyectarOrdenComisionForm:proyectarOrdenComisionTV:regionesPendientesComisionDT,
                                         :proyectarOrdenComisionForm:proyectarOrdenComisionTV:zoomAreaB"
                                         oncomplete="cargarMapaZoomToFeature('#{proyeccionOrdenComisionOfertas.applicationClientName}',
                                         '#{proyeccionOrdenComisionOfertas.tokenParam}',
                                         '#{proyeccionOrdenComisionOfertas.moduleLayer}',
                                         '#{proyeccionOrdenComisionOfertas.moduleTools}',
                                         '#{proyeccionOrdenComisionOfertas.manzanaCodigo}');"
                                         disabled="#{empty proyeccionOrdenComisionOfertas.manzanaCodigo}" />
                        <p:commandButton value="Limpiar selección" ajax="true"
                                         action="#{proyeccionOrdenComisionOfertas.eliminarManzanasSeleccionadas}"
                                         update=":proyectarOrdenComisionForm:proyectarOrdenComisionTV"
                                         icon="ui-icon-trash" onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide();"
                                         disabled="#{empty proyeccionOrdenComisionOfertas.manzanaCodigo}" />
                    </h:panelGrid>

                </p:tab>

                <p:tab title="Comisiones pendientes por enviar a aprobación">

                    <legend>
                        <h:outputText styleClass="legendTitle" value="Aprobar comisiones" />
                    </legend>

                    <p:spacer height="20" width="0" />

                    <p:dataTable id="comisionesPendientesAprobacionId"
                                 widgetVar="comisionesPendientesWV"
                                 value="#{proyeccionOrdenComisionOfertas.comisionesPorAprobar}"
                                 var="comisionPorAprobar"
                                 selection="#{proyeccionOrdenComisionOfertas.selectedComisionesPorAprobar}"
                                 rowKey="#{comisionPorAprobar.id}" paginator="true" rows="5"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                                 {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"
                                 emptyMessage="No hay comisiones pendientes por enviar a aprobación.">

                        <p:column selectionMode="multiple" style="width:18px" />

                        <f:facet name="header">
                            <h:outputText
                                value="Comisiones pendientes por enviar a aprobación" />
                        </f:facet>

                        <p:column headerText="No. Comisión">
                            <p:commandLink
                                action="#{proyeccionOrdenComisionOfertas.cargarDocuemntoOrdenPractica}"
                                update=":msgsPOC, 
                                :viewMemo:vistaMemoForm"
                                onstart="statusDialog2.show();"
                                oncomplete="statusDialog2.hide();
                                handleCompleteSIC(xhr, status, args, memorandoWV, true);">
                                <h:outputText id="memorandoComisionParaAprobar"
                                              value="#{comisionPorAprobar.numero}"
                                              styleClass="commandLinkStyle" />
                                <f:setPropertyActionListener value="#{comisionPorAprobar}"
                                                             target="#{proyeccionOrdenComisionOfertas.selectedComisionPorAprobar}" />
                            </p:commandLink>
                        </p:column>

                        <p:column headerText="Recolectores">
                            <p:dataList value="#{comisionPorAprobar.regionCapturaOfertas}"
                                        var="recolector"
                                        rendered="#{not empty comisionPorAprobar.regionCapturaOfertas}"
                                        styleClass="outputTextStyle">
                                #{recolector.asignadoRecolectorNombre}
                            </p:dataList>
                        </p:column>

                        <p:column headerText="Fecha inicio">
                            <h:outputText value="#{comisionPorAprobar.fechaInicio}"
                                          styleClass="outputTextStyle">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}"
                                                   timeZone="GMT-5" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Fecha fin">
                            <h:outputText value="#{comisionPorAprobar.fechaFin}"
                                          styleClass="outputTextStyle">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}"
                                                   timeZone="GMT-5" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Duración">
                            <h:outputText id="duracionComisionParaAprobar"
                                          value="#{comisionPorAprobar.duracion} días"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Regiones asociadas">
                            <p:dataList value="#{comisionPorAprobar.regionCapturaOfertas}"
                                        var="region">#{region.id} - #{region.areaCapturaOferta.departamento.nombre} - #{region.areaCapturaOferta.municipio.nombre}</p:dataList>
                        </p:column>

                    </p:dataTable>

                    <p:spacer height="10" />

                    <h:panelGrid columns="2" cellspacing="7">
                        <p:commandButton value="Modificar comision" ajax="true"
                                         action="#{proyeccionOrdenComisionOfertas.cargarComisionParaEdicion}"
                                         update=":detalleComisionOfertaForm" icon="ui-icon-pencil"
                                         onstart="statusDialog2.show();"
                                         oncomplete="detallesComisionWV.show(); statusDialog2.hide();"
                                         onclick="if (comisionesPendientesWV.selection.length != 1) {
                                                     alert('Debe seleccionar una comisión para editar.');
                                                     return false;
                                                 }" />
                        <p:commandButton value="Enviar a aprobación"
                                         action="#{proyeccionOrdenComisionOfertas.enviarComisionesAprobacion}"
                                         update=":proyectarOrdenComisionForm:proyectarOrdenComisionTV, :msgsPOC"
                                         icon="ui-icon-circle-arrow-e" onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide();"
                                         onclick="if (comisionesPendientesWV.selection.length == 0) {
                                                     alert('Debe seleccionar al menos una comisión para aprobar.');
                                                     return false;
                                                 }" />
                    </h:panelGrid>

                </p:tab>
            </p:tabView>
            <p:separator style="width:925px;height:3px" />
            <p:spacer height="7" width="0" />
            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar"
                                 action="#{proyeccionOrdenComisionOfertas.cerrar}"
                                 icon="ui-icon-circle-close" immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />
        </h:form>


        <!-- ...................... dialogs  ................................... -->

        <p:dialog widgetVar="detallesComisionWV" header="Datos de la comisión"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="700">
            <ui:include src="detalleComisionOferta.xhtml">
                <ui:param name="managedBeanParam"
                          value="#{proyeccionOrdenComisionOfertas}" />
                <ui:param name="comisionOfertaParam"
                          value="#{proyeccionOrdenComisionOfertas.selectedComisionPorAprobar}" />
                <ui:param name="componentsToUpdateParam"
                          value=":proyectarOrdenComisionForm:proyectarOrdenComisionTV,
                          :comisionesOfPGrid,
                          :viewMemo:pepo" />
                <ui:param name="banderaEsCreacionParam"
                          value="#{proyeccionOrdenComisionOfertas.banderaEsCreacion}" />
            </ui:include>
        </p:dialog>

        <!-- CC PARA MOSTRAR DOCUMENTO -->
        <misc:visualizadorMemorandosCC id="viewMemo" thisWVName="memorandoWV"
                                       radicarButtonVisible="false"
                                       componentsToUpdateOnClose=":proyectarOrdenComisionForm:proyectarOrdenComisionTV,
                                       :comisionesOfPGrid"
                                       urlDocumento="#{proyeccionOrdenComisionOfertas.ordenComisionReporte.urlWebReporte}"
                                       fileContent="#{proyeccionOrdenComisionOfertas.ordenComisionReporte.streamedContentReporte}"
                                       documentoGenerado="#{proyeccionOrdenComisionOfertas.ordenComisionReporte ne null}"
                                       jsOnHide="detallesComisionWV.hide(); comisionAreasOfertasDialogWV.hide();" />

        <p:dialog header="Comisionar áreas para ofertas"
                  widgetVar="comisionAreasOfertasDialogWV" appendToBody="true"
                  closable="true" minimizable="false" resizable="false" dynamic="true"
                  modal="true" width="900">
            <ui:include src="asocRegnCaptOfertaAComision.xhtml" id="cofModal1" />
        </p:dialog>


        <ui:include src="../../../util/visorGeografico.xhtml" />

    </ui:define>
</ui:composition>